#ifndef MD_INTEGRATOR_H
#define MD_INTEGRATOR_H

/*
    Copyright (C) 2010  Thomas Schrøder

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    LICENSE.txt file for license details.
*/

// The Integrator interface. Inherit this interface to build your own integrator.
class Integrator{
  
 public:
  // Virtual destructor to prevent a possible memory leak.
  // Implementation to prevent warning in g++. 
  virtual ~Integrator(){};
  
  virtual void Integrate() = 0;

  virtual void SetTimeStep(float dt) = 0;
  virtual float GetTimeStep() = 0;

  virtual double GetKineticEnergy() = 0;
};

#endif // MD_INTEGRATOR_H
